class Solution {
    static class Interval {
        int s, e;
        Interval(int s, int e) {
            this.s = s;
            this.e = e;
        }
    };
    public int minTaps(int n, int[] ranges) {
        Interval intervals[] = new Interval[ranges.length]; 
        for (int i = 0; i < ranges.length; ++i) {
            intervals[i] = new Interval(i - ranges[i], i + ranges[i]);
        }
        Arrays.sort(intervals, new Comparator<Interval>() {
            @Override
            public int compare (Interval a, Interval b) {
                return Integer.compare(a.s, b.s);
            }
        });
        int covered_up_to = 0, cur_rightmost = 0, total = 0;
        for (int i = 0; i < intervals.length && covered_up_to < n; ++i) {
        	// System.out.println("(" + intervals[i].s + ", " + intervals[i].e + ")");
        	//System.out.println("Rightmost: " + cur_rightmost);
            if (intervals[i].s > cur_rightmost) break;
            if (intervals[i].s > covered_up_to) {
                covered_up_to = cur_rightmost;
                // System.out.println("New interval up to : " + cur_rightmost);
                ++total;
            }
            if (intervals[i].e > cur_rightmost) {
                cur_rightmost = intervals[i].e;
                if (cur_rightmost >= n) {
                	covered_up_to = cur_rightmost;
                	++total;
                }
            }
        }
        if (covered_up_to < n) return -1;
        return total;
    }
}
